import { world } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:ouija", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`summon furnicraft:herobrine ~ ~ ~ facing ~ ~ ~10`)
                    chairEntity.runCommand(`playsound ouija1.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'south':
                    chairEntity.runCommand(`summon furnicraft:herobrine ~ ~ ~ facing ~ ~ ~-10`)
                    chairEntity.runCommand(`playsound ouija1.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'east':
                    chairEntity.runCommand(`summon furnicraft:herobrine ~ ~ ~ facing ~-10 ~ ~`)
                    chairEntity.runCommand(`playsound ouija1.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'west':
                    chairEntity.runCommand(`summon furnicraft:herobrine ~ ~ ~ facing ~10 ~ ~`)
                    chairEntity.runCommand(`playsound ouija1.on @a[r=10] ~ ~ ~ 1`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:satanic", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound mob.satanic.spawn @a[r=10] ~ ~ ~ 1`)
                    chairEntity.runCommand(`summon lightning_bolt ~ ~120 ~`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound mob.satanic.spawn @a[r=10] ~ ~ ~ 1`)
                    chairEntity.runCommand(`summon lightning_bolt ~ ~120 ~`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound mob.satanic.spawn @a[r=10] ~ ~ ~ 1`)
                    chairEntity.runCommand(`summon lightning_bolt ~ ~120 ~`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound mob.satanic.spawn @a[r=10] ~ ~ ~ 1`)
                    chairEntity.runCommand(`summon lightning_bolt ~ ~120 ~`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:ventilador_on", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`summon furnicraft:ventilador ~ ~0.1 ~`)
                    break;
                case 'south':
                    chairEntity.runCommand(`summon furnicraft:ventilador ~ ~0.1 ~`)
                    break;
                case 'east':
                    chairEntity.runCommand(`summon furnicraft:ventilador ~ ~0.1 ~`)
                    break;
                case 'west':
                    chairEntity.runCommand(`summon furnicraft:ventilador ~ ~0.1 ~`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:ventilador_off", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:ventilador,r=1] furnicraft:despawn`)
                    break;
                case 'south':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:ventilador,r=1] furnicraft:despawn`)
                    break;
                case 'east':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:ventilador,r=1] furnicraft:despawn`)
                    break;
                case 'west':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:ventilador,r=1] furnicraft:despawn`)
                    break;
            }

        },
    });
});