import { world } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:chests", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:chest,r=1] run summon furnicraft:chest`)
                    break;
                case 'south':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:chest,r=1] run summon furnicraft:chest`)
                    break;
                case 'east':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:chest,r=1] run summon furnicraft:chest`)
                    break;
                case 'west':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:chest,r=1] run summon furnicraft:chest`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:cabinet", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:chest,r=1] run summon furnicraft:chest ~ ~ ~-0.4`)
                    break;
                case 'south':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:chest,r=1] run summon furnicraft:chest ~ ~ ~0.4`)
                    break;
                case 'east':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:chest,r=1] run summon furnicraft:chest ~0.4 ~ ~`)
                    break;
                case 'west':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:chest,r=1] run summon furnicraft:chest ~-0.4 ~ ~`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:basura", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`summon furnicraft:basura_chest ~~0.5~`)
                    break;
                case 'south':
                    chairEntity.runCommand(`summon furnicraft:basura_chest ~~0.5~`)
                    break;
                case 'east':
                    chairEntity.runCommand(`summon furnicraft:basura_chest ~~0.5~`)
                    break;
                case 'west':
                    chairEntity.runCommand(`summon furnicraft:basura_chest ~~0.5~`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:estufa", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`summon furnicraft:estufa_trade ~~~`)
                    break;
                case 'south':
                    chairEntity.runCommand(`summon furnicraft:estufa_trade ~~~`)
                    break;
                case 'east':
                    chairEntity.runCommand(`summon furnicraft:estufa_trade ~~~`)
                    break;
                case 'west':
                    chairEntity.runCommand(`summon furnicraft:estufa_trade ~~~`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:microondas", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`summon furnicraft:microondas_trade ~~~`)
                    break;
                case 'south':
                    chairEntity.runCommand(`summon furnicraft:microondas_trade ~~~`)
                    break;
                case 'east':
                    chairEntity.runCommand(`summon furnicraft:microondas_trade ~~~`)
                    break;
                case 'west':
                    chairEntity.runCommand(`summon furnicraft:microondas_trade ~~~`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:kill", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`kill @e[family=fchests,r=1.5]`)
                    chairEntity.runCommand(`kill @e[type=item,r=2]`)
                    break;
                case 'south':
                    chairEntity.runCommand(`kill @e[family=fchests,r=1.5]`)
                    chairEntity.runCommand(`kill @e[type=item,r=2]`)
                    break;
                case 'east':
                    chairEntity.runCommand(`kill @e[family=fchests,r=1.5]`)
                    chairEntity.runCommand(`kill @e[type=item,r=2]`)
                    break;
                case 'west':
                    chairEntity.runCommand(`kill @e[family=fchests,r=1.5]`)
                    chairEntity.runCommand(`kill @e[type=item,r=2]`)
                    break;
            }

        },
    });
});
