import { world } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:lights_on", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`function lightson`)
                    break;
                case 'south':
                    chairEntity.runCommand(`function lightson`)
                    break;
                case 'east':
                    chairEntity.runCommand(`function lightson`)
                    break;
                case 'west':
                    chairEntity.runCommand(`function lightson`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:lights_off", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`function lightsoff`)
                    break;
                case 'south':
                    chairEntity.runCommand(`function lightsoff`)
                    break;
                case 'east':
                    chairEntity.runCommand(`function lightsoff`)
                    break;
                case 'west':
                    chairEntity.runCommand(`function lightsoff`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:ventilador_on", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`summon furnicraft:ventilador ~ ~0.1 ~`)
                    break;
                case 'south':
                    chairEntity.runCommand(`summon furnicraft:ventilador ~ ~0.1 ~`)
                    break;
                case 'east':
                    chairEntity.runCommand(`summon furnicraft:ventilador ~ ~0.1 ~`)
                    break;
                case 'west':
                    chairEntity.runCommand(`summon furnicraft:ventilador ~ ~0.1 ~`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:ventilador_off", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:ventilador,r=1] furnicraft:despawn`)
                    break;
                case 'south':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:ventilador,r=1] furnicraft:despawn`)
                    break;
                case 'east':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:ventilador,r=1] furnicraft:despawn`)
                    break;
                case 'west':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:ventilador,r=1] furnicraft:despawn`)
                    break;
            }

        },
    });
});