import { world } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:market_check", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound market.check @a[r=10] ~ ~ ~ 0.1 1`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound market.check @a[r=10] ~ ~ ~ 0.1 1`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound market.check @a[r=10] ~ ~ ~ 0.1 1`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound market.check @a[r=10] ~ ~ ~ 0.1 1`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:cash_register", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound cash.register @a[r=10] ~ ~ ~ 0.2 1`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound cash.register @a[r=10] ~ ~ ~ 0.2 1`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound cash.register @a[r=10] ~ ~ ~ 0.2 1`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound cash.register @a[r=10] ~ ~ ~ 0.2 1`)
                    break;
            }

        },
    });
});
