import { world } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:spawn_ride_resbaladilla", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`summon furnicraft:resbaladilla_entity ~ ~0.5 ~ facing ~ ~ ~10`)
                    chairEntity.runCommand(`playanimation @a[r=6] animation.resbaladilla_entity.north`)
                    chairEntity.runCommand(`camera @a[r=6] set minecraft:free pos ~3 ~4 ~3 facing @s`)
                    break;
                case 'south':
                    chairEntity.runCommand(`summon furnicraft:resbaladilla_entity ~ ~0.5 ~ facing ~ ~ ~-10`)
                    chairEntity.runCommand(`playanimation @a[r=6] animation.resbaladilla_entity.south`)
                    chairEntity.runCommand(`camera @a[r=6] set minecraft:free pos ~-3 ~4 ~-3 facing @s`)
                    break;
                case 'east':
                    chairEntity.runCommand(`summon furnicraft:resbaladilla_entity ~ ~0.5 ~ facing ~-10 ~ ~`)
                    chairEntity.runCommand(`playanimation @a[r=6] animation.resbaladilla_entity.east`)
                    chairEntity.runCommand(`camera @a[r=6] set minecraft:free pos ~-4~4~3 facing @s`)
                    break;
                case 'west':
                    chairEntity.runCommand(`summon furnicraft:resbaladilla_entity ~ ~0.5 ~ facing ~10 ~ ~`)
                    chairEntity.runCommand(`playanimation @a[r=6] animation.resbaladilla_entity.west`)
                    chairEntity.runCommand(`camera @a[r=6] set minecraft:free pos ~4~4~-3 facing @s`)
                    break;
            }
            player.runCommand(`ride @a[r=6] start_riding @e[type=furnicraft:resbaladilla_entity,c=1] teleport_rider`)

        },
    });
});
