import { world } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:click_on", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound interuptor.on @a[r=6] ~ ~ ~ 0.2`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound interuptor.on @a[r=6] ~ ~ ~ 0.2`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound interuptor.on @a[r=6] ~ ~ ~ 0.2`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound interuptor.on @a[r=6] ~ ~ ~ 0.2`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:click_off", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound interuptor.off @a[r=6] ~ ~ ~ 0.2`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound interuptor.off @a[r=6] ~ ~ ~ 0.2`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound interuptor.off @a[r=6] ~ ~ ~ 0.2`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound interuptor.off @a[r=6] ~ ~ ~ 0.2`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:fire_off", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound fire.ignite @a[r=6] ~ ~ ~ 0.5`)
                    chairEntity.runCommand(`playsound block.campfire.crackle @a[r=6] ~ ~ ~ 0.5`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound fire.ignite @a[r=6] ~ ~ ~ 0.5`)
                    chairEntity.runCommand(`playsound block.campfire.crackle @a[r=6] ~ ~ ~ 0.5`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound fire.ignite @a[r=6] ~ ~ ~ 0.5`)
                    chairEntity.runCommand(`playsound block.campfire.crackle @a[r=6] ~ ~ ~ 0.5`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound fire.ignite @a[r=6] ~ ~ ~ 0.5`)
                    chairEntity.runCommand(`playsound block.campfire.crackle @a[r=6] ~ ~ ~ 0.5`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:fire_on", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound random.fizz @a[r=6] ~ ~ ~ 0.5`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound random.fizz @a[r=6] ~ ~ ~ 0.5`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound random.fizz @a[r=6] ~ ~ ~ 0.5`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound random.fizz @a[r=6] ~ ~ ~ 0.5`)
                    break;
            }

        },
    });
});